        include "flib.h"
        include "doslib.h"
        include "tidos.h"
        include "tios.h"
        include "keys.h"
        xdef    _main
        xdef    _comment
_main:
        btst.b  #0,doslib::status_byte
        beq     no_dos
                              ;Update cur_fold_hand
        cmp.w   #$0B,doslib::cur_fold_hand
        beq     no_update
        jsr     doslib::GetStrCurFold
        move.w  tios::SYM_ENTRY.hVal(a0),doslib::cur_fold_hand
                                        ;store handle of current folder
no_update:
        clr.w   dir_status_byte
        clr.w   size_files
ExtractNextSwitch:
        jsr     doslib::GetNextComm
        tst.l   d0
        beq     no_more_comms
        move.l  #doslib::command,a3   ;a3 points to places in command
        cmp.b   #DIVIDE,(a3)          ;look for "/" character
        bne     not_switch
        add.l   #1,a3

        cmp.b   #W_LOWER,(a3)
        beq     Switch_w

        cmp.b   #P_LOWER,(a3)
        beq     Switch_p

        jsr     doslib::Scroll
        clr.w   doslib::char_pos
        move.l  #doslib::str.inv_switch,a0      ;load "Invalid switch - "
        jsr     doslib::PutText                 ;print it
        add.w   d0,doslib::char_pos
        move.l  #doslib::command,a0             ;load the switch
        jsr     doslib::PutText                 ;print the switch
        rts                                     ;done

Switch_p:
        bset.b  #0,dir_status_byte       ;signify that /p switch is recognized        
        bra     ExtractNextSwitch

Switch_w:
        bset.b  #1,dir_status_byte      ;signify that /w switch is recognized
        bra     ExtractNextSwitch

not_switch:
        jsr     doslib::Scroll
        move.w  #4,doslib::char_pos
        move.l  #doslib::command,-(sp)        ;push file/folder name to find
        move.w  doslib::cur_fold_hand,-(sp)     ;push handle of folder/root
        jsr     tios::FindSymEntry              ;attempt to find it
        lea     6(sp),sp
        cmp.l   #0,a0                           ;was it found?
        beq     not_found_1                     ;file was not found
        cmp.w   #$0B,doslib::cur_fold_hand      ;are we in the root?
        beq     not_switch_fold                 ;then print folder info
        move.l  a0,a2
        bsr     PrintFile                       ;print file info
        rts                                     ;done
not_switch_fold:
        move.l  a0,a2
        bsr     PrintFolder                     ;print folder info
        rts
not_found_1:
        clr.w   doslib::char_pos
        move.l  #doslib::str.file_not_found,a0
        jsr     doslib::PutText       ;print "File not found"
        rts

no_more_comms:
        move.w  #1,p_count
        jsr     doslib::Scroll
        lea     two_dots(PC),a0
        move.w  #DIR_PRINT_OFFSET,doslib::char_pos
        jsr     doslib::PutText          ;print two dots 
        move.w  doslib::cur_fold_hand,d0
        tios::DEREF d0,a2       ;get add. of var list
        move.w  2(a2),d3        ;get the size of the list
        tst.w   d3
        beq     empty_folder
        move.w  d3,num_files    ;store away the number of files
        sub.w   #1,d3           ;set up counter
        add.l   #4,a2           ;get the first entry

dir_loop_1:                     ;a2 because a2 is not destroyed by ROM
        jsr     doslib::Scroll
        move.w  #DIR_PRINT_OFFSET,doslib::char_pos ;offset a little off of the edge
        cmp.w   #$0B,doslib::cur_fold_hand      ;are we in the root?
        beq     dir_PrintFolder                   ;if yes, print folder name
        bsr     PrintFile                   ;if not, print file name
        btst.b  #1,dir_status_byte          ;see if /w switch is activated
        beq     file_no_w                   ;if not, skip the following
        tst.w   d3                          ;are we at the end of file list?
        beq     file_no_w                   ;then skip the following
        move.w  #DIR_2ND_COLMN,doslib::char_pos
        adda.l  #12,a2                  ;goto next file struct
        bsr     PrintFile
        subq.w  #1,d3                   ;decrement the counter
 
file_no_w:
        bra     dir_resume
dir_PrintFolder:
        bsr     PrintFolder
dir_resume:
        add.w   #1,p_count
        cmp.w   #MAX_LINES,p_count          ;is it time to pause yet?
        bne     dir_resume_1                ;if not, resume
        move.w  #1,p_count                  ;reset counter
        btst.b  #0,dir_status_byte          ;is the /p switch activated?
        beq     dir_resume_1                ;if not, resume
        jsr     doslib::Scroll
        clr.w   doslib::char_pos
        lea     key_to_cont(PC),a0          ;load "Press any key to continue"
        jsr     doslib::PutText             ;print it
;        move.w  #DIR_PRINT_OFFSET,doslib::char_pos
        jsr     flib::idle_loop             ;pause
dir_resume_1:
        add.l   #12,a2          ;goto next entry
        dbra.w  d3,dir_loop_1

        jsr     doslib::Scroll
        move.w  #4,doslib::char_pos
        clr.l   d0
        move.w  num_files,d0
        jsr     doslib::PrintDecNum   ;print the number of files in the folder
        add.w   d0,doslib::char_pos
        add.w   #1,doslib::char_pos
        cmp.w   #$0B,doslib::cur_fold_hand      ;are we in the root?
        bne     display_files_info              ;if not, handle the files
        lea     folders(PC),a0
        jsr     doslib::PutText                 ;print "folders"
        rts                                     ;done

display_files_info:
        lea     files(PC),a0            ;print "files"
        jsr     doslib::PutText
        add.w   d0,doslib::char_pos
        add.w   #3,doslib::char_pos
        move.w  size_files,d0
        jsr     doslib::PrintDecNum  ;print the total size of files in the folder
        add.w   d0,doslib::char_pos
        add.w   #1,doslib::char_pos
        lea     bytes(PC),a0
        jsr     doslib::PutText         ;print "bytes"


empty_folder:
        rts
        

PrintFolder:             ;input: a2 = sym_struct address
        PutChar #BRACKET_OPEN,doslib::line_pos,doslib::char_pos ;open bracket
        add.w   #1,doslib::char_pos
        move.l  a2,a0                   ;get address of file name
        jsr     doslib::PutText         ;display filename
        add.w   d0,doslib::char_pos
        PutChar #BRACKET_CLOSE,doslib::line_pos,doslib::char_pos ;close bracket
        move.w  #DIR_2ND_COLMN,doslib::char_pos
        move.w  tios::SYM_ENTRY.hVal(a2),d0     ;get handle of folder struct
        tios::DEREF d0,a0               ;get pointer to fold struct
        clr.l   d0
        adda.l  #2,a0
        move.w  (a0),d0                ;get # of files in the folder        
        jsr     doslib::PrintDecNum     ;print # of files
        add.w   d0,doslib::char_pos
        add.w   #1,doslib::char_pos
        lea     files(PC),a0
        jsr     doslib::PutText         ;print "files"
        rts

PrintFile:
        move.l  a2,a0           ;get address of filename
        jsr     doslib::PutText ;display file name          
        add.w   d0,doslib::char_pos           ;go to where to put dot
        PutChar #DOT,doslib::line_pos,doslib::char_pos ;put the dot
        addq.w  #1,doslib::char_pos
        move.l  a2,a1
        jsr     doslib::GetFileType     ;input: a1=sym struct add. out: a0 = add of type string
        jsr     doslib::PutText         ;display file type  
        move.w  tios::SYM_ENTRY.hVal(a2),d0     ;get handle of file struct
        tios::DEREF d0,a0               ;get pointer to file struct
        clr.l   d0
        move.w  (a0),d0
        add.w   #2,d0                   ;get file size
        add.w   d0,size_files           ;add to total size
        btst.b  #1,dir_status_byte      ;test for /w switch
        bne     file_w_set              ;if set, skip the size display
        move.w  #DIR_2ND_COLMN,doslib::char_pos   ;size display
        jsr     doslib::PrintDecNum     ;convert to decimal and print
file_w_set:
        rts

no_dos:
        jsr     doslib::DosNotRunning
        rts

_comment        dc.b    "DIR 0.5 TiDOS command",0
num_files       dc.w    0
size_files      dc.w    0
p_count         dc.w    1
dir_status_byte dc.w    0
;bit 0 set: /p switch active
;bit 1 set: /w switch active

files           dc.b    "files",0
folders         dc.b    "folders",0
bytes           dc.b    "bytes",0
two_dots        dc.b    "..",0
key_to_cont     dc.b    "Press any key to continue...",0,0
        end
