        include "doslib.h"
        include "tios.h"

        xdef    _main
        xdef    _comment

_main:
        btst.b  #0,doslib::status_byte
        beq     no_dos
        jsr     doslib::GetNextComm
        tst.l   d0                      ;was anything entered?
        beq     param_missing
        move.l  #doslib::command,-(sp)          ;push it
        move.w  doslib::cur_fold_hand,-(sp)     ;push folder handle
        jsr     tios::FindSymEntry      ;get add.
        lea     6(sp),sp                ;returns 0 if not found
        cmp.l   #0,a0
        beq     ren_filenotfound        ;
        move.l  a0,a3                ;store address
        jsr     doslib::GetNextComm
        tst.l   d0                      ;was anything entered?
        beq     param_missing
        move.l  #doslib::command,-(sp)          ;is filename already ised?
        move.w  doslib::cur_fold_hand,-(sp)
        jsr     tios::FindSymEntry
        lea     6(sp),sp
        cmp.l   #0,a0
        bne     ren_file_exists         ;if address returned, this file already exists
        move.l  #8,-(sp)               ;size
        move.l  #doslib::command,-(sp)         ;source
        move.l  a3,-(sp)               ;dest (a3 = a0, see above)
        jsr     tios::strncpy          ;copy data
        lea     12(sp),sp              ;structure begins with filename
        rts
ren_filenotfound:
        jsr     doslib::Scroll          
        lea     file_not_found(PC),a0
        clr.w   doslib::char_pos
        jsr     doslib::PutText           
        add.w   d0,doslib::char_pos
        move.l  #doslib::command,a0
        jsr     doslib::PutText           
        rts
ren_file_exists:
        lea     4(sp),sp
        jsr     doslib::Scroll          
        clr.w   doslib::char_pos
        lea     duplicate(PC),a0
        jsr     doslib::PutText           
        rts
param_missing:
        clr.w   doslib::char_pos
        jsr     doslib::Scroll
        move.l  #doslib::req_param,a0
        jsr     doslib::PutText
        rts

no_dos:
        jsr     doslib::DosNotRunning
        rts

_comment        dc.b    "REN 1.1 TiDOS command",0
new_name        ds.w    10
duplicate       dc.b    "Duplicate filename or file in use",0
file_not_found  dc.b    "File not found - ",0

        end
