        include "kernel.h"
;        include "graphlib.h"
;        include "filelib.h"
;        include "dosmess.inc"
        include "tios.h"
        include "flib.h"
        include "keys.h"
        include "tidos.h"
        include "doslib.h"
        xdef    _main
        xdef    _comment
;include tidos.sdb
_main:
        bsr     Init

CreatePrompt:
        bsr     InitCommBuff
        jsr     doslib::PrintPath
        move.w  doslib::cur_fold_hand,d0        
        cmp.w   FOLDER_LIST_HANDLE,d0   ;are we in the root directory?
        beq     skip_slash
        PutChar #GREATER_THAN,doslib::line_pos,doslib::char_pos
        add.w   #1,doslib::char_pos
skip_slash:
        move.w  doslib::char_pos,d0
        move.w  d0,begin_comm_char

InputCommand:
        move.l  #doslib::command_buffer,a6
WaitKey:
        nop                     ;for breakpoint
        jsr     doslib::Getche  ;get and print keystroke
        cmp.w   #ENTER,d0       ;returns keystroke in d0
        beq     ProcessCommand
        cmp.w   #BKSPC,d0
        beq     BackSpace
        cmp.w   #ESC,d0
        beq     Exit
        cmp.w   #SPACE,d0
        beq     Space
        bsr     FormatInput     ;input: d0.w = char, output: (a6)+.b=formatted char
        addq.w  #1,doslib::char_pos
;        bsr     PutPosIndicator
        bra     WaitKey

ProcessCommand:
        tst.b   doslib::command_buffer  ;was anything entered?
        bne     analyze_command
        jsr     doslib::Scroll          
        bra     CreatePrompt
analyze_command:
        clr.w   found_flag      ;reset the found flag
        clr.w   doslib::comm_offset ;reset the current command indicator
        jsr     doslib::GetNextComm
        cmp.l   #8,d0        ;in no case should the 1st command exceed 8 chars
        beq     Return_Here
;        move.l  #4,-(sp)     ;push size
;        move.l  #doslib::command        ;push *str1
;        pea     exit(PC)                ;push *str2
;        jsr     tios::strncmp           ;has "exit" been entered?
   
        bsr     TryExecDosComm
        btst.b  #1,doslib::status_byte  ;is exit flag set?
        bne     Exit                    ;if not 0, exit

Return_Here:
        tst.w   found_flag      ;test if a command was found
        bne     command_processed    ;if not 0, command was dealt with
        jsr     doslib::Scroll          
        lea     bad_command(PC),a0
        clr.w   doslib::char_pos
        jsr     doslib::PutText           
command_processed:                            
        jsr     doslib::Scroll          
        bra     CreatePrompt

BackSpace:
        clr.b   -(a6)               ;delete preceding byte in the buffer
        move.w  doslib::char_pos,d1
        move.w  begin_comm_char,d2
        cmp.w   d1,d2
        beq     WaitKey
;        bsr     RemPosIndicator
        subq.w  #1,doslib::char_pos
        PutChar #SPACE,doslib::line_pos,doslib::char_pos
;        bsr     PutPosIndicator
        bra     WaitKey

Space:
        clr.b  (a6)+             ;insert a zero
        PutChar #SPACE,doslib::line_pos,doslib::char_pos        ;put a space
        addq.w   #1,doslib::char_pos ;increment the char postition
        bra     WaitKey

Exit:
        bclr.b  #0,doslib::status_byte
        rts

;--------------------------------------------------------;
;       Subroutines
;--------------------------------------------------------;
TryExecDosComm:
        pea     dos_fold(PC)            ;push "tidos"
        move.w  FOLDER_LIST_HANDLE,-(sp);list of folders
        jsr     tios::FindSymEntry      ;get address of tidos struct
        lea     6(sp),sp
        move.l  #doslib::command,-(sp)  ;try to find the command
        move.w  tios::SYM_ENTRY.hVal(a0),-(sp)  ;push handle of tidos list
        jsr     tios::FindSymEntry      ;get address of command
        lea     6(sp),sp
        cmp.l   #0,a0                   ;was this command even found?
        bne     exec_command
                                ;try running fargo prog in the current folder
        jsr     doslib::GetStrCurFold ;a0 = add of cur. fold. struct.
        move.l  #doslib::command,-(sp)  ;push name
        move.w  tios::SYM_ENTRY.hVal(a0),-(sp)  ;push folder handle
        jsr     tios::FindSymEntry
        lea     6(sp),sp
        cmp.l   #0,a0           ;was such file found in the current folder?
        beq     file_not_found
exec_command:
        movem.l d0-d7/a0-a6,-(sp)
        move.w  tios::SYM_ENTRY.hVal(a0),-(sp)  ;push handle
        jsr     kernel::exec
        lea     2(sp),sp
        tst.l   d0                              ;success?
        bne     failure_exec_comm
        move.w  #1,found_flag           ;set the found flag
failure_exec_comm:
        movem.l (sp)+,d0-d7/a0-a6
file_not_found:
        rts
                
InitCommBuff:
        move.l  #doslib::command_buffer,a0
;        move.l  #doslib::command,a1
        move.w  #LINE_LENGTH-1,d0
clear_loop1:
        clr.b   (a0)+
;        clr.b   (a1)+
        dbra.w  d0,clear_loop1
        rts

Init:
        jsr     flib::zap_screen
        move.w  #1,-(sp)        ;medium font
        jsr     tios::FontSetSys
        clr.w   doslib::status_byte
        bset.b  #0,doslib::status_byte  ;signify that DOS is running
        lea     2(sp),sp
        move.l  #8,-(sp)        ;push # of bytes
        move.w  #0,-(sp)        ;push char
        move.l  #doslib::cur_fold,-(sp)
        jsr     tios::memset    ;clear that mem area
        lea     10(sp),sp
        move.l  #4,-(sp)        ;push # bytes
        pea     main_fold(PC)   ;push source
        move.l  #doslib::cur_fold,-(sp)  ;push dest
        jsr     tios::strncpy   ;copy
        lea     12(sp),sp
        clr.w   doslib::char_pos
        clr.w   doslib::line_pos
        bsr     UpdateHdlCurFold
        rts                                           

UpdateHdlCurFold:         ;update folder handle when cur_fold has changed
        move.l  #doslib::cur_fold,-(sp)
        move.w  FOLDER_LIST_HANDLE,-(sp)
        jsr     tios::FindSymEntry
        lea     6(sp),sp
        move.w  tios::SYM_ENTRY.hVal(a0),doslib::cur_fold_hand ;store the handle of
        rts

FormatInput:         ;input: d0.w = char output: (a6)+.b = formatted char
        move.w  d0,-(sp)        ;push d0
        cmp.w   #Z_UPPER,d0
        ble     is_cap
        bra     store_key
is_cap:
        cmp.w   #A_UPPER,d0
        bge     convert_cap
        bra     store_key
convert_cap:
        add.w   #32,d0
store_key:
        move.b  d0,(a6)+         ;store the character
        move.w  (sp)+,d0
        rts


PutPosIndicator:                        ;These will get more elaborate
        PutChar #25,doslib::line_pos,doslib::char_pos
        rts
RemPosIndicator:
        PutChar #SPACE,doslib::line_pos,doslib::char_pos
        rts
;--------------------------------------------------------;

_comment        dc.b    "tiDOS ",169,"1998 Anton Ivanov",0
        
;--------------------------------------------------------;
;        DATA

;command_buffer  ds.b    40      ;
begin_comm_char dc.w    0
path            dc.b    "main\",0
;doslib::line_pos    dc.w    0           
;cur_char_pos    dc.w    0
prog            dc.b    "prog",0
file_types      dc.b    "ASM ",0,"LIB ",0,"PROG",0,"FUNC",0,"MAT",0,"LIST",0,"MACR"
scrbuf_hdlnum   dc.w    0
two_char_comms  dc.b    "cd",0
three_char_comms        dc.b    "cls",0,"dir",0,"ren",0   ;alphabetically
found_flag      dc.w    0
main_fold       dc.b    "main",0
dos_fold        dc.b    "tidos",0
full_screen_hdl      dc.w    0
full_screen_hdl_add  dc.l    0
add_struct_cur_prog dc.l    0
num_files       dc.w    0

;--------------------------------------------------------;
;messages
bad_command     dc.b    "Bad command or file name",0


;CD


;DIR
cd_two_dots     dc.b    "..",0


;REN

;--------------------------------------------------------;

;--------------------------------------------------------;
;        BSS

;screen  ds.b    3840            ;Virtual Screen
;command_buffer  ds.b    LINE_LENGTH      ;
;command         ds.b    LINE_LENGTH
;current_drive   dc.b    0       ;0=Ram
;--------------------------------------------------------;
        end
